/********************************************************************
 * cclist.c     30-NOV-1991            Y.Takeuchi (TIT)             *
 *                                                                  *
 * original: cc.c on SUN4 by Y.Yasu (KEK)                           *
 * for SUN-SPARC SF-VME K2917 K3922                                 *
 *                                                                  *
 * 24-JUN-1992 Y.Takeuchi    fix bugs of cc_swap_a(),               *
 *                           cc_head(), cc_move**_head().           *
 * 13-JUL-1992 Y.Takeuchi    delete "NCC", modify "splx" etc.       *
 * 30-NOV-1992 Y.Takeuchi    modify waitint(), TIMEOUT_VALUE etc.   *
 * 25-JAN-1993 Y.Takeuchi    fix bug of ptr_prev_head[?]            *
 *  5-MAR-1993 Y.Takeuchi    modify for unified UNIX camlib         *
 * 17-MAR-1993 Y.Takeuchi    modify for re-execution                *
 * 30-MAR-1993 Y.Takeuchi    fix bugs of read24(), read16() (NOQ))  *
 ********************************************************************/
#define Tolong(i)  (cc->ptr_list[(i)] + (cc->ptr_list[(i) + 1] << 16))

/* gloval variables for list processing */
static u_short *ptr_prev_head; 


next_instruction(cc)
struct cc_device *cc;
{
    if (cc->branch_flag)
	cc->branch_flag = 0;
    else
	cc->ptr_list += (0xFF00 & *cc->ptr_list) >> 8;
    return 0;
}


flush_buf(cc)
struct cc_device *cc;
{
    cc_sys_status = copyout((caddr_t)data_area, (caddr_t)cc->ptr_udata,
			    cc->len_kdata * sizeof(u_short));
    cc->ptr_udata += cc->len_kdata;
    cc->len_udata += cc->len_kdata;
    cc->len_kdata = 0;
    cc->ptr_kdata = data_area;
}


check_buf(cc, wc)
struct cc_device *cc;
int wc;                                     /* wc: word counts */
{
    if (cc->len_kdata + wc >= CC_LIST_MAX_DATA &&
	cc->len_kdata + wc < cc->len_udata_t - cc->len_udata)
	    flush_buf(cc);
    if (cc->len_kdata + wc >= cc->len_udata_t - cc->len_udata) {
        return CC_STA_LIST_EMPTY;
    }
    else
	return 0;
}


cc_stop(cc)
struct cc_device *cc;
{
    return CC_STA_LIST_STOP;
}


cc_read16(cc)
struct cc_device *cc;
{
    register int status;

    if (status = check_buf(cc, 1))
	return status;
    if (status = camac_s(cc, BIT16, cc->ptr_list[1], cc->ptr_kdata))
        return status;
    /* increment data pointer (if CAMAC Q=1) */
    if ((cc->camac_qx & NOQ) == 0) {
	cc->ptr_kdata += 1;
	cc->len_kdata += 1;
    }
    return 0;
}


cc_read24(cc)
struct cc_device *cc;
{
    register int status;

    if (status = check_buf(cc, 2))
	return status;
    if (status = camac_s(cc, BIT24, cc->ptr_list[1], cc->ptr_kdata))
        return status;
    /* increment data pointer (if CAMAC Q=1) */
    if ((cc->camac_qx & NOQ) == 0) {
	cc->ptr_kdata += 2;
	cc->len_kdata += 2;
    }
    return 0;
}


cc_read16_a(cc)
struct cc_device *cc;
{
    cc->a_reg = 0;
    return camac_s(cc, BIT16, cc->ptr_list[1], ((u_short *)&cc->a_reg + 1));
}


cc_read24_a(cc)
struct cc_device *cc;
{
    return camac_s(cc, BIT24, cc->ptr_list[1], (u_short *)&cc->a_reg);
}


cc_write16(cc)
struct cc_device *cc;
{
    return camac_s(cc, BIT16, cc->ptr_list[1], &cc->ptr_list[2]);
}


cc_write24(cc)
struct cc_device *cc;
{
    int dat;

    dat = Tolong(2);
    return camac_s(cc, BIT24, cc->ptr_list[1], (u_short *)&dat);
}


cc_write16_a(cc)
struct cc_device *cc;
{
    return camac_s(cc, BIT16, cc->ptr_list[1], ((u_short *)&cc->a_reg + 1));
}


cc_write24_a(cc)
struct cc_device *cc;
{
    return camac_s(cc, BIT24, cc->ptr_list[1], (u_short *)&cc->a_reg);
}


cc_ndt(cc)
struct cc_device *cc;
{
    u_short dummy;

    return camac_s(cc, BIT16, cc->ptr_list[1], &dummy);
}


cc_setcrate_a(cc)
struct cc_device *cc;
{
    if (cc->a_reg >= 0 && cc->a_reg < MAX_CRATE)
        cc->cur_crate = cc->a_reg;
    return 0;
}


cc_setcrate(cc)
struct cc_device *cc;
{
    if (cc->ptr_list[1] < MAX_CRATE)
        cc->cur_crate = cc->ptr_list[1];
    return 0;
}


cc_genz(cc)
struct cc_device *cc;
{
    register int status;
    int dat;

    if (status = camac_s(cc, BIT24, NAF(30, 0, 1), (u_short *)&dat))
	return status;
    dat |= 1;
    return camac_s(cc, BIT24, NAF(30, 0, 17), (u_short *)&dat);
}


cc_genc(cc)
struct cc_device *cc;
{
    register int status;
    int dat;

    if (status = camac_s(cc, BIT24, NAF(30, 0, 1), (u_short *)&dat))
	return status;
    dat |= 2;
    return camac_s(cc, BIT24, NAF(30, 0, 17), (u_short *)&dat);
}


cc_remi(cc)
struct cc_device *cc;
{
    register int status;
    int dat;

    if (status = camac_s(cc, BIT24, NAF(30, 0, 1), (u_short *)&dat))
	return status;
    dat &= ~4;
    return camac_s(cc, BIT24, NAF(30, 0, 17), (u_short *)&dat);
}


cc_seti(cc)
struct cc_device *cc;
{
    register int status;
    int dat;

    if (status = camac_s(cc, BIT24, NAF(30, 0, 1), (u_short *)&dat))
	return status;
    dat |= 4;
    return camac_s(cc, BIT24, NAF(30, 0, 17), (u_short *)&dat);
}


cc_enbint(cc)
struct cc_device *cc;
{
    register int status;
    int dat;

#ifdef CC_SPARC_LIST_EXTENSION
    dat = cc->a_reg;
#else
    dat = 0xFFFFFF;                          /* mask */
#endif
    if (status = camac_s(cc, BIT24, NAF(30, 13, 17), (u_short *)&dat))
	return status;
    if (status = camac_s(cc, BIT24, NAF(30, 0, 1), (u_short *)&dat))
	return status;
    dat |= 0x0100;
    return camac_s(cc, BIT24, NAF(30, 0, 17), (u_short *)&dat);
}


cc_dsbint(cc)
struct cc_device *cc;
{
    register struct mb_device *md = cc->md;
    register int status;
    int dat;

    /* disable LAM */
    cc->k->lamc = INT_AUTO_CLEAR | (md->md_intpri & 7);

    dat = 0x0;                              /* mask */
    if (status = camac_s(cc, BIT24, NAF(30, 13, 17), (u_short *)&dat))
	return status;
    if (status = camac_s(cc, BIT24, NAF(30, 0, 1), (u_short *)&dat))
	return status;
    dat &= ~0x0100;
    return camac_s(cc, BIT24, NAF(30, 0, 17), (u_short *)&dat);
}


cc_qwait(cc)
struct cc_device *cc;
{
    register int status, i;
    int dat;

    cc->camac_qx = status = 0;
    for (i=0; status==0 && (cc->camac_qx & NOQ)!=0 && i<cc->ptr_list[2];i++)
	status = camac_s(cc, BIT24, cc->ptr_list[1], (u_short *)&dat);
    if (i >= cc->ptr_list[2])
	return CC_STA_LIST_TIMEOUT;
    else
        return 0;
}


cc_qs16(cc)
struct cc_device *cc;
{
    register u_short mode, naf;
    register int status, len;
    int retlen;

    mode = BLOCK | BIT16 | QSTOP;
    naf = cc->ptr_list[1];
    len = cc->ptr_list[2];
    flush_buf(cc);
    if (status = check_buf(cc, len))
        return status;
    return camac_b(cc, mode, naf, len, &retlen);
}


cc_qs24(cc)
struct cc_device *cc;
{
    register u_short mode, naf;
    register int status, len;
    int retlen;

    mode = BLOCK | BIT24 | QSTOP;
    naf = cc->ptr_list[1];
    len = cc->ptr_list[2];
    flush_buf(cc);
    if (status = check_buf(cc, len * 2))
        return status;
    return camac_b(cc, mode, naf, len, &retlen);
}


cc_qs16_a(cc)
struct cc_device *cc;
{
    register u_short mode, naf;
    register int status, len;
    int retlen;

    mode = BLOCK | BIT16 | QSTOP;
    naf = cc->ptr_list[1];
    len = cc->a_reg;
    flush_buf(cc);
    if (status = check_buf(cc, len))
        return status;
    return camac_b(cc, mode, naf, len, &retlen);
}


cc_qs24_a(cc)
struct cc_device *cc;
{
    register u_short mode, naf;
    register int status, len;
    int retlen;

    mode = BLOCK | BIT24 | QSTOP;
    naf = cc->ptr_list[1];
    len = cc->a_reg;
    flush_buf(cc);
    if (status = check_buf(cc, len * 2))
        return status;
    return camac_b(cc, mode, naf, len, &retlen);
}


cc_as16(cc)
struct cc_device *cc;
{
    register u_short mode, naf;
    register int status, len;
    int retlen;

    mode = BLOCK | BIT16 | QSCAN;
    naf = cc->ptr_list[1];
    len = cc->ptr_list[2];
    flush_buf(cc);
    if (status = check_buf(cc, len))
        return status;
    return camac_b(cc, mode, naf, len, &retlen);
}


cc_as24(cc)
struct cc_device *cc;
{
    register u_short mode, naf;
    register int status, len;
    int retlen;

    mode = BLOCK | BIT24 | QSCAN;
    naf = cc->ptr_list[1];
    len = cc->ptr_list[2];
    flush_buf(cc);
    if (status = check_buf(cc, len * 2))
        return status;
    return camac_b(cc, mode, naf, len, &retlen);
}


cc_as16_a(cc)
struct cc_device *cc;
{
    register u_short mode, naf;
    register int status, len;
    int retlen;

    mode = BLOCK | BIT16 | QSCAN;
    naf = cc->ptr_list[1];
    len = cc->a_reg;
    flush_buf(cc);
    if (status = check_buf(cc, len))
        return status;
    return camac_b(cc, mode, naf, len, &retlen);
}


cc_as24_a(cc)
struct cc_device *cc;
{
    register u_short mode, naf;
    register int status, len;
    int retlen;

    mode = BLOCK | BIT24 | QSCAN;
    naf = cc->ptr_list[1];
    len = cc->a_reg;
    flush_buf(cc);
    if (status = check_buf(cc, len * 2))
        return status;
    return camac_b(cc, mode, naf, len, &retlen);
}


cc_igq16(cc)
struct cc_device *cc;
{
    register u_short mode, naf;
    register int status, len;
    int retlen;

    mode = BLOCK | BIT16 | QIGNO;
    naf = cc->ptr_list[1];
    len = cc->ptr_list[2];
    flush_buf(cc);
    if (status = check_buf(cc, len))
        return status;
    return camac_b(cc, mode, naf, len, &retlen);
}


cc_igq24(cc)
struct cc_device *cc;
{
    register u_short mode, naf;
    register int status, len;
    int retlen;

    mode = BLOCK | BIT24 | QIGNO;
    naf = cc->ptr_list[1];
    len = cc->ptr_list[2];
    flush_buf(cc);
    if (status = check_buf(cc, len * 2))
        return status;
    return camac_b(cc, mode, naf, len, &retlen);
}


cc_igq16_a(cc)
struct cc_device *cc;
{
    register u_short mode, naf;
    register int status, len;
    int retlen;

    mode = BLOCK | BIT16 | QIGNO;
    naf = cc->ptr_list[1];
    len = cc->a_reg;
    flush_buf(cc);
    if (status = check_buf(cc, len))
        return status;
    return camac_b(cc, mode, naf, len, &retlen);
}


cc_igq24_a(cc)
struct cc_device *cc;
{
    register u_short mode, naf;
    register int status, len;
    int retlen;

    mode = BLOCK | BIT24 | QIGNO;
    naf = cc->ptr_list[1];
    len = cc->a_reg;
    flush_buf(cc);
    if (status = check_buf(cc, len * 2))
        return status;
    return camac_b(cc, mode, naf, len, &retlen);
}


int cc_move_as(cc)
struct cc_device *cc; {
    cc->s_reg = cc->a_reg;
    return 0;
}

int cc_move_at(cc)
struct cc_device *cc; {
    cc->t_reg = cc->a_reg;
    return 0;
}

int cc_move_sa(cc)
struct cc_device *cc; {
    cc->a_reg = cc->s_reg;
    return 0;
}

int cc_move_st(cc)
struct cc_device *cc; {
    cc->t_reg = cc->s_reg;
    return 0;
}

int cc_move_ta(cc)
struct cc_device *cc; {
    cc->a_reg = cc->t_reg;
    return 0;
}

int cc_move_ts(cc)
struct cc_device *cc; {
    cc->s_reg = cc->t_reg;
    return 0;
}

int cc_move32_a(cc)
struct cc_device *cc;
{
    cc->a_reg = Tolong(1);
    return 0;
}

int cc_move32_s(cc)
struct cc_device *cc;
{
    cc->s_reg = Tolong(1);
    return 0;
}

int cc_move32_t(cc)
struct cc_device *cc;
{
    cc->t_reg = Tolong(1);
    return 0;
}

int cc_move16_a_ptr(cc)
struct cc_device *cc;
{
    register int status;

    if (status = check_buf(cc, 1))
	return status;
    *cc->ptr_kdata++ = (u_short)cc->a_reg;
    cc->len_kdata++;
    return 0;
}

int cc_move32_a_ptr(cc)
struct cc_device *cc;
{
   register int status;

    if (status = check_buf(cc, 2))
	return status;
    *cc->ptr_kdata++ = *((u_short *)&cc->a_reg);
    *cc->ptr_kdata++ = *((u_short *)&cc->a_reg + 1);
    cc->len_kdata += 2;
    return 0;
}

int cc_move16_ptr(cc)
struct cc_device *cc;
{
    register int status;

    if (status = check_buf(cc, 1))
        return status;
    *cc->ptr_kdata++ = cc->ptr_list[1];
    cc->len_kdata++;
    return 0;
}

int cc_move32_ptr(cc)
struct cc_device *cc;
{
    register int status;

    if (status = check_buf(cc, 2))
	return status;
    *cc->ptr_kdata++ = cc->ptr_list[2];
    *cc->ptr_kdata++ = cc->ptr_list[1];
    cc->len_kdata += 2;
    return 0;
}

int cc_move16_a_head(cc)
struct cc_device *cc;
{
    cc_sys_status = copyout((caddr_t)((u_short *)&cc->a_reg + 1),
			    (caddr_t)&ptr_prev_head[cc->ptr_list[1]-1], 2);
    return 0;
}

int cc_move16_head_a(cc)
struct cc_device *cc;
{
    cc->a_reg = 0;
    cc_sys_status = copyin((caddr_t)&ptr_prev_head[cc->ptr_list[1]-1],
			   (caddr_t)((u_short *)&cc->a_reg + 1), 2);
    return 0;
}

int cc_move16_head(cc)
struct cc_device *cc;
{
    cc_sys_status = copyout((caddr_t)&cc->ptr_list[2],
			    (caddr_t)&ptr_prev_head[cc->ptr_list[1]-1], 2);
    return 0;
}

int cc_load_ptr(cc)
struct cc_device *cc;
{
    cc->a_reg = cc->len_udata + cc->len_kdata;
    return 0;
}

int cc_load_remain(cc)
struct cc_device *cc;
{
    cc->a_reg = cc->len_udata_t - (cc->len_udata + cc->len_kdata);
    return 0;
}

int cc_load_timer(cc)
struct cc_device *cc;
{
/*
    cc->a_reg = 0;
    return 0;
*/

/*** temporary ***/
    return klexe(cc, klist[0].name);
}

int cc_load_count(cc)
struct cc_device *cc;
{
    cc->a_reg = cc->event_count;
    return 0;
}

int cc_load_qx(cc)
struct cc_device *cc;
{
    cc->a_reg = cc->camac_qx;
    return 0;
}

int cc_head(cc)
struct cc_device *cc;
{
    ptr_prev_head = cc->ptr_udata;
    cc->ptr_udata += cc->ptr_list[1];
    cc->len_udata += cc->ptr_list[1];
    return 0;
}

int cc_exchg_at(cc)
struct cc_device *cc;
{
    register u_int i;

    i = cc->a_reg;
    cc->a_reg = cc->t_reg;
    cc->t_reg = i;
    return 0;
}

int cc_swap_a(cc)
struct cc_device *cc;
{
    register u_short temp;

    swap.longs = cc->a_reg;
    temp = swap.shorts[0];
    swap.shorts[0] = swap.shorts[1];
    swap.shorts[1] = temp;
    cc->a_reg = swap.longs;
    return 0;
}


int cc_bis32_at(cc)
struct cc_device *cc; {
    cc->t_reg |= cc->a_reg;
    return 0;
}

int cc_bis32_ta(cc)
struct cc_device *cc; {
    cc->a_reg |= cc->t_reg;
    return 0;
}

int cc_bis32_a(cc)
struct cc_device *cc;
{
    cc->a_reg |= Tolong(1);
    return 0;
}

int cc_bis32_t(cc)
struct cc_device *cc;
{
    cc->t_reg |= Tolong(1);
    return 0;
}

int cc_bic32_at(cc)
struct cc_device *cc; {
    cc->t_reg &= ~cc->a_reg;
    return 0;
}

int cc_bic32_ta(cc)
struct cc_device *cc; {
    cc->a_reg &= ~cc->t_reg;
    return 0;
}

int cc_bic32_a(cc)
struct cc_device *cc;
{
    cc->a_reg &= ~Tolong(1);
    return 0;
}

int cc_bic32_t(cc)
struct cc_device *cc;
{
    cc->t_reg &= ~Tolong(1);
    return 0;
}

int cc_add32_at(cc)
struct cc_device *cc;
{
    cc->t_reg += cc->a_reg;
    return 0;
}

int cc_add32_ta(cc)
struct cc_device *cc;
{
    cc->a_reg += cc->t_reg;
    return 0;
}

int cc_add32_a(cc)
struct cc_device *cc;
{
    cc->a_reg += Tolong(1);
    return 0;
}

int cc_add32_t(cc)
struct cc_device *cc;
{
    cc->t_reg += Tolong(1);
    return 0;
}

int cc_sub32_at(cc)
struct cc_device *cc;
{
    cc->t_reg -= cc->a_reg;
    return 0;
}

int cc_sub32_ta(cc)
struct cc_device *cc;
{
    cc->a_reg -= cc->t_reg;
    return 0;
}

int cc_sub32_a(cc)
struct cc_device *cc;
{
    cc->a_reg -= Tolong(1);
    return 0;
}

int cc_sub32_t(cc)
struct cc_device *cc;
{
    cc->t_reg -= Tolong(1);
    return 0;
}

int cc_mul32_at(cc)
struct cc_device *cc;
{
    cc->t_reg *= cc->a_reg;
    return 0;
}

int cc_mul32_ta(cc)
struct cc_device *cc;
{
    cc->a_reg *= cc->t_reg;
    return 0;
}

int cc_mul32_a(cc)
struct cc_device *cc;
{
    cc->a_reg *= Tolong(1);
    return 0;
}

int cc_mul32_t(cc)
struct cc_device *cc;
{
    cc->t_reg *= Tolong(1);
    return 0;
}

int cc_div32_at(cc)
struct cc_device *cc;
{
    if (cc->a_reg == 0)
        return CC_STA_LIST_ZERODIV;
    cc->t_reg /= cc->a_reg;
    return 0;
}

int cc_div32_ta(cc)
struct cc_device *cc;
{
    if (cc->t_reg == 0)
        return CC_STA_LIST_ZERODIV;
    cc->a_reg /= cc->t_reg;
    return 0;
}

int cc_div32_a(cc)
struct cc_device *cc;
{
    register int i;

    if ((i = Tolong(1)) == 0)
        return CC_STA_LIST_ZERODIV;
    cc->a_reg /= i;
    return 0;
}


int cc_div32_t(cc)
struct cc_device *cc;
{
    register int i;

    if ((i = Tolong(1)) == 0)
        return CC_STA_LIST_ZERODIV;
    cc->t_reg /= i;
    return 0;
}

int cc_waitint(cc)
struct cc_device *cc;
{
    register struct mb_device *md = cc->md;
    int s;

    if (cc->execution == 0) {
	cc->interrupt = 0;
	cc->k->lamc = INT_AUTO_CLEAR | INT_ENABLE | (md->md_intpri & 7);
    }
    s = spl5();
    if (cc->interrupt & CC_INT_LAM) {
	cc->interrupt &= ~CC_INT_LAM;
	cc->execution = 0;
 	return 0;
    }
    if (cc->execution == 0) {
#ifdef CC_SPARC_LIST_EXTENSION
	timeout(cctimeout, cc, cc->a_reg * hz);
#else
	timeout(cctimeout, cc, CC_TIMEOUT_LAM * hz);
#endif
	cc->execution = 1;
    }
    else
        uprintf("waitint: re-exec...\n");

    sleep((caddr_t)cc , CCLPRI);
    splx(s);
    cc->execution = 0;

    if (cc->interrupt & CC_INT_LAM) {
	cc->interrupt &= ~CC_INT_LAM;
	return 0;
    }
    else {
        return CC_STA_LIST_TIMEOUT;
    }
}


int cc_waitevent(cc)
struct cc_device *cc;
{
    register struct mb_device *md = cc->md;
    int s;

    if (cc->execution == 0) {
	cc->interrupt = 0;
	cc->k->lamc = INT_AUTO_CLEAR | INT_ENABLE | (md->md_intpri & 7);
    }

    s = spl5();
    if (cc->interrupt & CC_INT_LAM) {
	cc->interrupt &= ~CC_INT_LAM;
	cc->event_count++;
	cc->execution = 0;
 	return 0;
    }
    if (cc->execution == 0) {
#ifdef CC_SPARC_LIST_EXTENSION
	timeout(cctimeout, cc, cc->a_reg * hz);
#else
	timeout(cctimeout, cc, CC_TIMEOUT_LAM * hz);
#endif
	cc->execution = 1;
    }
    else
        uprintf("waitint: re-exec...\n");

    sleep((caddr_t)cc , CCLPRI);
    splx(s);
    cc->execution = 0;

    if (cc->interrupt & CC_INT_LAM) {
	cc->interrupt &= ~CC_INT_LAM;
	cc->event_count++;
	return 0;
    }
    else {
	return CC_STA_LIST_TIMEOUT;
    }
}


int cc_br(cc)
struct cc_device *cc;
{
    cc->ptr_list = list_area + cc->ptr_list[1] - 1;
    cc->branch_flag = 1;
    return 0;
}

int cc_beq(cc)
struct cc_device *cc;
{
    if (cc->t_reg == Tolong(2)) {
	cc->ptr_list = list_area + cc->ptr_list[1] - 1;
	cc->branch_flag = 1;
    }
    return 0;
}

int cc_bne(cc)
struct cc_device *cc;
{
    if (cc->t_reg != Tolong(2)) {
	cc->ptr_list = list_area + cc->ptr_list[1] - 1;
	cc->branch_flag = 1;
    }
    return 0;
}

int cc_bgt(cc)
struct cc_device *cc;
{
    if (cc->t_reg > Tolong(2)) {
	cc->ptr_list = list_area + cc->ptr_list[1] - 1;
	cc->branch_flag = 1;
    }
    return 0;
}

int cc_bge(cc)
struct cc_device *cc;
{
    if (cc->t_reg >= Tolong(2)) {
	cc->ptr_list = list_area + cc->ptr_list[1] - 1;
	cc->branch_flag = 1;
    }
    return 0;
}

int cc_blt(cc)
struct cc_device *cc;
{
    if (cc->t_reg < Tolong(2)) {
	cc->ptr_list = list_area + cc->ptr_list[1] - 1;
	cc->branch_flag = 1;
    }
    return 0;
}

int cc_ble(cc)
struct cc_device *cc;
{
    if (cc->t_reg <= Tolong(2)) {
	cc->ptr_list = list_area + cc->ptr_list[1] - 1;
	cc->branch_flag = 1;
    }
    return 0;
}

int cc_bbc(cc)
struct cc_device *cc;
{
    if (!(cc->t_reg & (1 << Tolong(2)))) {
	cc->ptr_list = list_area + cc->ptr_list[1] - 1;
	cc->branch_flag = 1;
    }
    return 0;
}

int cc_bbs(cc)
struct cc_device *cc;
{
    if (cc->t_reg & (1 <<  Tolong(2))) {
	cc->ptr_list = list_area + cc->ptr_list[1] - 1;
	cc->branch_flag = 1;
    }
    return 0;
}
