/************************************************************************
 * sreg3.c                24-MAR-1992             Y.Takeuchi            *
 *                                                                      *
 * cc -O -o sreg3 sreg3.c                                               *
 * Show SFVME iack registers                                            *
 * sreg3 [iack level]                                                   *
 *                                                                      *
 * 17-SEP-1992 suport SFVME-116         modified by Y.Takeuchi          *
 ************************************************************************/
#include <stdio.h>
#include <sys/file.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sbusdev/sfvmereg.h>
#include <sbusdev/sfvmevar.h>
#include "sfvme_config.h"

#ifdef SFVME-116
#define ADDRESS_OFFSET    0x3FF000
#else
#define ADDRESS_OFFSET    0x7FF000
#endif

#define SIZE              0x100

main(argc, argv)
int argc;
char *argv[];
{
    char    *open_arg = SBUS_SLOT;
    int     page_size;
    off_t   page_start;
    int     page_offset;
    caddr_t page_addr;
    int     fd;
    int i;
    vme_interface_t *v;

    if ((fd = open(open_arg, O_RDWR)) < 0) {
	printf("Open error %s \n", open_arg);
	exit(1);
    }

    page_size   = getpagesize();
    page_start  = (ADDRESS_OFFSET / page_size) * page_size;
    page_offset = (ADDRESS_OFFSET % page_size);

    page_addr = mmap((caddr_t)0, SIZE + page_offset, PROT_READ | PROT_WRITE,
		     MAP_SHARED, fd, page_start);

    if (page_addr == (caddr_t)-1) {
	printf("Map error!\n");
	exit(2);
    }

    v = (vme_interface_t *)page_addr;

    i = 3;
    if (argc > 1)
      i = atoi(argv[1]);

    printf("\n");
    printf("    LEVEL : IACK%d\n", i);
    printf("    IACK%d = ", i);
    switch (i) {
      case 1:
	printf("%02x\n", v->vme_iack1);
	break;
      case 2:
	printf("%02x\n", v->vme_iack2);
	break;
      case 3:
	printf("%02x\n", v->vme_iack3);
	break;
      case 4:
	printf("%02x\n", v->vme_iack4);
	break;
      case 5:
	printf("%02x\n", v->vme_iack5);
	break;
      case 6:
	printf("%02x\n", v->vme_iack6);
	break;
      case 7:
	printf("%02x\n", v->vme_iack7);
	break;
    }

    close(fd);
}
